# Copyright (C) 2005 Helge Tesdal <info@plonesolutions.com>
# Plone Solutions AS http://www.plonesolutions.com
"""
Patches.
"""
from Products.UnicodeErrorDetector.config import DETECT_UNICODE_PATCH

# PATCH 1
#
# Helps debugging unicode errors.
#
# If Unicode is found by StringIO when appending text, it raises an error.

if DETECT_UNICODE_PATCH:
    from TAL.TALInterpreter import FasterStringIO
    from types import UnicodeType
    from Products.PageTemplates.PageTemplate import PageTemplate

    class UnicodeDebugStringIO(FasterStringIO):
        """Detect unicode version of StringIO.
        """
        def write(self, s):
            #assert self.pos == self.len
            if isinstance(s, UnicodeType):
                raise RuntimeError("Unicode in template output: %s %s <span style='color: red'>THIS IS WHERE THE ERROR IS</span>" % (s.encode('utf-8'),''.join(self.buflist)))
                #raise RuntimeError("Unicode in template output: %s" % s.encode('utf-8'))
            self.buflist.append(s)
            self.len = self.pos = self.pos + len(s)

    def StringIO(self):
        """ Return the unicode String IO"""
        return UnicodeDebugStringIO()

    if not hasattr(PageTemplate, 'old_StringIO'):
        # Apply patch
        PageTemplate.old_StringIO = PageTemplate.StringIO
        PageTemplate.StringIO = StringIO


